diff --git a/testing/tools/autotry/autotry.py b/testing/tools/autotry/autotry.py
index 7b0350b610..5c359c09c1 100644
--- a/testing/tools/autotry/autotry.py
+++ b/testing/tools/autotry/autotry.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import argparse
 import itertools
 import os
@@ -12,7 +13,8 @@ import which
 
 from collections import defaultdict
 
-import ConfigParser
+import six.moves.configparser
+import six
 
 
 def arg_parser():
@@ -96,7 +98,7 @@ class TryArgumentParser(object):
 
     def consume(self):
         try:
-            self.token = self.tokens.next()
+            self.token = next(self.tokens)
         except StopIteration:
             self.token = (self.EOF, None)
 
@@ -277,14 +279,14 @@ class AutoTry(object):
         return os.path.join(self.mach_context.state_dir, "autotry.ini")
 
     def load_config(self, name):
-        config = ConfigParser.RawConfigParser()
+        config = six.moves.configparser.RawConfigParser()
         success = config.read([self.config_path])
         if not success:
             return None
 
         try:
             data = config.get("try", name)
-        except (ConfigParser.NoSectionError, ConfigParser.NoOptionError):
+        except (six.moves.configparser.NoSectionError, six.moves.configparser.NoOptionError):
             return None
 
         kwargs = vars(arg_parser().parse_args(self.split_try_string(data)))
@@ -292,21 +294,21 @@ class AutoTry(object):
         return kwargs
 
     def list_presets(self):
-        config = ConfigParser.RawConfigParser()
+        config = six.moves.configparser.RawConfigParser()
         success = config.read([self.config_path])
 
         data = []
         if success:
             try:
                 data = config.items("try")
-            except (ConfigParser.NoSectionError, ConfigParser.NoOptionError):
+            except (six.moves.configparser.NoSectionError, six.moves.configparser.NoOptionError):
                 pass
 
         if not data:
             print("No presets found")
 
         for name, try_string in data:
-            print("%s: %s" % (name, try_string))
+            print(("%s: %s" % (name, try_string)))
 
     def split_try_string(self, data):
         return re.findall(r'(?:\[.*?\]|\S)+', data)
@@ -315,7 +317,7 @@ class AutoTry(object):
         assert data.startswith("try: ")
         data = data[len("try: "):]
 
-        parser = ConfigParser.RawConfigParser()
+        parser = six.moves.configparser.RawConfigParser()
         parser.read([self.config_path])
 
         if not parser.has_section("try"):
@@ -388,7 +390,7 @@ class AutoTry(object):
 
         suites = tests if not intersection else {}
         paths = set()
-        for flavor, flavor_tests in paths_by_flavor.iteritems():
+        for flavor, flavor_tests in paths_by_flavor.items():
             suite = self.flavor_suites[flavor]
             if suite not in suites and (not intersection or suite in tests):
                 for job_name in self.flavor_jobs[flavor]:
@@ -423,7 +425,7 @@ class AutoTry(object):
             parts.append("--try-test-paths %s" % " ".join(sorted(paths)))
 
         args_by_dest = {v['dest']: k for k, v in AutoTry.pass_through_arguments.items()}
-        for dest, value in extras.iteritems():
+        for dest, value in extras.items():
             assert dest in args_by_dest
             arg = args_by_dest[dest]
             action = AutoTry.pass_through_arguments[arg]['action']
@@ -438,7 +440,7 @@ class AutoTry(object):
                 parts.append(arg)
 
         try_syntax = " ".join(parts)
-        if extras.get('artifact') and 'all' in suites.keys():
+        if extras.get('artifact') and 'all' in list(suites.keys()):
             message = ('You asked for |-u all| with |--artifact| but compiled-code tests ({tests})'
                        ' can\'t run against an artifact build. Try listing the suites you want'
                        ' instead. For example, this syntax covers most suites:\n{try_syntax}')
@@ -457,8 +459,8 @@ class AutoTry(object):
         args = ['git'] + list(args)
         ret = subprocess.call(args)
         if ret:
-            print('ERROR git command %s returned %s' %
-                  (args, ret))
+            print(('ERROR git command %s returned %s' %
+                  (args, ret)))
             sys.exit(1)
 
     def _git_push_to_try(self, msg):
@@ -485,8 +487,8 @@ class AutoTry(object):
             return subprocess.check_output(args).strip('\0').split('\0')
         except subprocess.CalledProcessError as e:
             print('Failed while determining files changed on this branch')
-            print('Failed whle running: %s' % args)
-            print(e.output)
+            print(('Failed whle running: %s' % args))
+            print((e.output))
             sys.exit(1)
 
     def _hg_find_changed_files(self):
@@ -501,8 +503,8 @@ class AutoTry(object):
         except subprocess.CalledProcessError as e:
             print('Failed while finding files changed since the last '
                   'public ancestor')
-            print('Failed whle running: %s' % hg_args)
-            print(e.output)
+            print(('Failed whle running: %s' % hg_args))
+            print((e.output))
             sys.exit(1)
 
     def find_changed_files(self):
@@ -521,7 +523,7 @@ class AutoTry(object):
                 hg_args = ['hg', 'push-to-try', '-m', msg]
                 subprocess.check_call(hg_args, stderr=subprocess.STDOUT)
             except subprocess.CalledProcessError as e:
-                print('ERROR hg command %s returned %s' % (hg_args, e.returncode))
+                print(('ERROR hg command %s returned %s' % (hg_args, e.returncode)))
                 print('\nmach failed to push to try. There may be a problem '
                       'with your ssh key, or another issue with your mercurial '
                       'installation.')
@@ -560,8 +562,8 @@ class AutoTry(object):
         changed_files = self.find_changed_files()
         if changed_files:
             if verbose:
-                print("Pushing tests based on modifications to the "
-                      "following files:\n\t%s" % "\n\t".join(changed_files))
+                print(("Pushing tests based on modifications to the "
+                      "following files:\n\t%s" % "\n\t".join(changed_files)))
 
             from mozbuild.frontend.reader import (
                 BuildReader,
@@ -578,9 +580,9 @@ class AutoTry(object):
 
             if verbose:
                 if paths:
-                    print("Pushing tests based on the following patterns:\n\t%s" %
-                          "\n\t".join(paths))
+                    print(("Pushing tests based on the following patterns:\n\t%s" %
+                          "\n\t".join(paths)))
                 if tags:
-                    print("Pushing tests based on the following tags:\n\t%s" %
-                          "\n\t".join(tags))
+                    print(("Pushing tests based on the following tags:\n\t%s" %
+                          "\n\t".join(tags)))
         return paths, tags
diff --git a/testing/tools/iceserver/iceserver.py b/testing/tools/iceserver/iceserver.py
index 85d0f3ee54..cd5134c971 100644
--- a/testing/tools/iceserver/iceserver.py
+++ b/testing/tools/iceserver/iceserver.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import ipaddr
 import socket
 import hmac
@@ -18,6 +19,7 @@ from string import Template
 from twisted.internet import reactor, protocol
 from twisted.internet.task import LoopingCall
 from twisted.internet.address import IPv4Address
+from functools import reduce
 
 MAGIC_COOKIE = 0x2112A442
 
@@ -321,7 +323,7 @@ class StunMessage(object):
         digest_buf = self.build(MESSAGE_INTEGRITY)
         # Trim off the MESSAGE-INTEGRITY attr
         digest_buf = digest_buf[:len(digest_buf) - 24]
-        password = passlib.utils.saslprep(unicode(password))
+        password = passlib.utils.saslprep(str(password))
         key_string = "{}:{}:{}".format(username, realm, password)
         md5 = hashlib.md5()
         md5.update(key_string)
@@ -367,10 +369,11 @@ class Allocation(protocol.DatagramProtocol):
         self.expiry = time.time()
         self.port = reactor.listenUDP(0, self, interface=v4_address)
 
-    def datagramReceived(self, data, (host, port)):
+    def datagramReceived(self, data, xxx_todo_changeme):
+        (host, port) = xxx_todo_changeme
         if not host in self.permissions:
-            print("Dropping packet from {}:{}, no permission on allocation {}"
-                  .format(host, port, self.transport.getHost()))
+            print(("Dropping packet from {}:{}, no permission on allocation {}"
+                  .format(host, port, self.transport.getHost())))
             return
 
         data_indication = StunMessage()
@@ -421,13 +424,13 @@ class StunHandler(object):
             if stun_message.method == SEND:
                 self.handle_send_indication(stun_message)
             else:
-                print("Dropping unknown indication method: {}"
-                      .format(stun_message.method))
+                print(("Dropping unknown indication method: {}"
+                      .format(stun_message.method)))
             return None
 
         if stun_message.msg_class != REQUEST:
-            print("Dropping STUN response, method: {}"
-                  .format(stun_message.method))
+            print(("Dropping STUN response, method: {}"
+                  .format(stun_message.method)))
             return None
 
         if stun_message.method == BINDING:
@@ -559,8 +562,8 @@ class StunHandler(object):
         try:
             allocation = allocations[self.get_allocation_tuple()]
         except KeyError:
-            print("Dropping send indication; no allocation for tuple {}"
-                  .format(self.get_allocation_tuple()))
+            print(("Dropping send indication; no allocation for tuple {}"
+                  .format(self.get_allocation_tuple())))
             return
 
         peer_address = indication.get_xor_address(XOR_PEER_ADDRESS)
@@ -578,8 +581,8 @@ class StunHandler(object):
             return
 
         if not peer_address.host in allocation.permissions:
-            print("Dropping send indication, no permission for {} on tuple {}"
-                  .format(peer_address.host, self.get_allocation_tuple()))
+            print(("Dropping send indication, no permission for {} on tuple {}"
+                  .format(peer_address.host, self.get_allocation_tuple())))
             return
 
         allocation.transport.write(data_attr.data,
@@ -594,7 +597,7 @@ class StunHandler(object):
 
     def make_error_response(self, request, code, reason=None):
         if reason:
-            print("{}: rejecting with {}".format(reason, code))
+            print(("{}: rejecting with {}".format(reason, code)))
         response = copy.deepcopy(request)
         response.attributes = []
         response.add_error_code(code, reason)
@@ -676,12 +679,12 @@ class TcpStunHandler(protocol.Protocol):
         self.stun_handler.data_received(data, self.address)
 
     def connectionLost(self, reason):
-        print("Lost connection from {}".format(self.address))
+        print(("Lost connection from {}".format(self.address)))
         # Destroy allocations that this connection made
         for key, allocation in allocations.items():
             if allocation.other_transport_handler == self:
-                print("Closing allocation due to dropped connection: {}"
-                      .format(key))
+                print(("Closing allocation due to dropped connection: {}"
+                      .format(key)))
                 del allocations[key]
                 allocation.close()
 
@@ -713,7 +716,7 @@ def prune_allocations():
     now = time.time()
     for key, allocation in allocations.items():
         if allocation.expiry < now:
-            print("Allocation expired: {}".format(key))
+            print(("Allocation expired: {}".format(key)))
             del allocations[key]
             allocation.close()
 
@@ -789,7 +792,7 @@ if __name__ == "__main__":
         lines = f.readlines();
         lines.pop(0); # Remove BEGIN CERTIFICATE
         lines.pop(); # Remove END CERTIFICATE
-        lines = map(string.strip, lines);
+        lines = list(map(string.strip, lines));
         certbase64 = string.join(lines, '');
 
         turns_url = ', "turns:' + hostname + '"'
@@ -810,11 +813,11 @@ if __name__ == "__main__":
 $cert_prop}]' # Hack to make it easier to override cert checks
 )
 
-    print(template.substitute(user=turn_user,
+    print((template.substitute(user=turn_user,
                               pwd=turn_pass,
                               hostname=hostname,
                               turns_url=turns_url,
-                              cert_prop=cert_prop))
+                              cert_prop=cert_prop)))
 
     reactor.run()
 
diff --git a/testing/tools/proxyserver/proxyserver.py b/testing/tools/proxyserver/proxyserver.py
index d7b2ef1610..a210fcff9b 100644
--- a/testing/tools/proxyserver/proxyserver.py
+++ b/testing/tools/proxyserver/proxyserver.py
@@ -45,6 +45,7 @@ TODO:
   items from the database and such.
 """
 
+from __future__ import print_function
 __version__ = "0.1"
 
 import os
@@ -54,13 +55,13 @@ import threading
 import shelve
 from optparse import OptionParser, OptionValueError
 
-import SocketServer
-import BaseHTTPServer
+import six.moves.socketserver
+import six.moves.BaseHTTPServer
 import socket
-import httplib
-from urlparse import urlsplit, urlunsplit
+import six.moves.http_client
+from urllib.parse import urlsplit, urlunsplit
 
-class HTTPRequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
+class HTTPRequestHandler(six.moves.BaseHTTPServer.BaseHTTPRequestHandler):
   server_version = "TalosProxy/" + __version__
   protocol_version = "HTTP/1.1"
 
@@ -69,9 +70,9 @@ class HTTPRequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
     if content:
       try:
         self.wfile.write(content)
-      except socket.error, e:
+      except socket.error as e:
         if options.verbose:
-          print "Got socket error %s" % e
+          print("Got socket error %s" % e)
     #self.close_connection = 1
   def do_HEAD(self):
     self.send_head()
@@ -108,8 +109,8 @@ class HTTPRequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
         return None
       else:
         if options.verbose:
-          print "Object %s was not in the cache" % self.path
-        conn = httplib.HTTPConnection(o.netloc)
+          print("Object %s was not in the cache" % self.path)
+        conn = six.moves.http_client.HTTPConnection(o.netloc)
         conn.request("GET", reqstring, headers=headers)
         res = conn.getresponse()
 
@@ -133,18 +134,18 @@ class HTTPRequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
       if "Content-Length" not in headers:
         self.send_header("Content-Length", str(len(content)))
       self.end_headers()
-    except socket.error, e:
+    except socket.error as e:
       if options.verbose:
-        print "Got socket error %s" % e
+        print("Got socket error %s" % e)
       return None
     return content
   def log_message(self, format, *args):
     if options.verbose:
-      BaseHTTPServer.BaseHTTPRequestHandler.log_message(self, format, *args)
+      six.moves.BaseHTTPServer.BaseHTTPRequestHandler.log_message(self, format, *args)
 
-class HTTPServer(SocketServer.ThreadingMixIn, BaseHTTPServer.HTTPServer):
+class HTTPServer(six.moves.socketserver.ThreadingMixIn, six.moves.BaseHTTPServer.HTTPServer):
   def __init__(self, address, handler):
-    BaseHTTPServer.HTTPServer.__init__(self, address, handler)
+    six.moves.BaseHTTPServer.HTTPServer.__init__(self, address, handler)
 
 class Cache(object):
   """Multithreaded cache uses the shelve module to store pages"""
@@ -176,7 +177,7 @@ class Cache(object):
     self.sem.acquire()
     self.semlock.release()
     try:
-      if not self.db.has_key(key):
+      if key not in self.db:
         return None
       # returns status, headers, content
       return self.db[key]
@@ -264,6 +265,6 @@ if __name__ == '__main__':
     while 1: time.sleep(1)
   except KeyboardInterrupt:
     if options.verbose:
-      print "Quittin' time..."
+      print("Quittin' time...")
 
 __all__ = ['run_proxy', 'configure_proxy']
diff --git a/testing/tools/websocketprocessbridge/websocketprocessbridge.py b/testing/tools/websocketprocessbridge/websocketprocessbridge.py
index 02418d0e67..3df0ec2d26 100644
--- a/testing/tools/websocketprocessbridge/websocketprocessbridge.py
+++ b/testing/tools/websocketprocessbridge/websocketprocessbridge.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 from twisted.internet import protocol, reactor
 from twisted.internet.task import LoopingCall
 import txws
@@ -99,7 +100,7 @@ if __name__ == "__main__":
 
     bridgeFactory = ProcessSocketBridgeFactory()
     reactor.listenTCP(int(args.port), txws.WebSocketFactory(bridgeFactory))
-    print("websocket/process bridge listening on port %s" % args.port)
+    print(("websocket/process bridge listening on port %s" % args.port))
     reactor.run()
 
 
diff --git a/testing/tps/create_venv.py b/testing/tps/create_venv.py
index 3d5417f8af..82139b9d4c 100755
--- a/testing/tps/create_venv.py
+++ b/testing/tps/create_venv.py
@@ -9,13 +9,15 @@ It's probably best to specify a path NOT inside the repo, otherwise
 all the virtualenv files will show up in e.g. hg status.
 """
 
+from __future__ import print_function
 import optparse
 import os
 import shutil
 import subprocess
 import sys
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 import zipfile
+import six
 
 
 here = os.path.dirname(os.path.abspath(__file__))
@@ -53,7 +55,7 @@ else:
 
 def download(url, target):
     """Downloads the specified url to the given target."""
-    response = urllib2.urlopen(url)
+    response = six.moves.urllib.request.urlopen(url)
     with open(target, 'wb') as f:
         f.write(response.read())
 
@@ -64,7 +66,7 @@ def setup_virtualenv(target, python_bin=None):
     script_path = os.path.join(here, 'virtualenv-%s' % VERSION_VIRTUALENV,
                                'virtualenv.py')
 
-    print 'Downloading virtualenv %s' % VERSION_VIRTUALENV
+    print('Downloading virtualenv %s' % VERSION_VIRTUALENV)
     zip_path = download(URL_VIRTUALENV + VERSION_VIRTUALENV,
                         os.path.join(here, 'virtualenv.zip'))
 
@@ -72,7 +74,7 @@ def setup_virtualenv(target, python_bin=None):
         with zipfile.ZipFile(zip_path, 'r') as f:
             f.extractall(here)
 
-        print 'Creating new virtual environment'
+        print('Creating new virtual environment')
         cmd_args = [sys.executable, script_path, target]
 
         if python_bin:
@@ -93,7 +95,7 @@ def update_configfile(source, target, replacements):
 
     with open(source) as config:
         for line in config:
-            for source_string, target_string in replacements.iteritems():
+            for source_string, target_string in replacements.items():
                 if target_string:
                     line = line.replace(source_string, target_string)
             lines.append(line)
@@ -153,7 +155,7 @@ def main():
 
     # Activate tps environment
     tps_env = os.path.join(target, activate_env)
-    execfile(tps_env, dict(__file__=tps_env))
+    exec(compile(open(tps_env, "rb").read(), tps_env, 'exec'), dict(__file__=tps_env))
 
     # Install TPS in environment
     subprocess.check_call([os.path.join(target, python_env),
@@ -182,13 +184,13 @@ def main():
                       '__SYNC_ACCOUNT_PASSPHRASE__': options.sync_passphrase})
 
     if not (options.username and options.password):
-        print '\nFirefox Account credentials not specified.'
+        print('\nFirefox Account credentials not specified.')
     if not (options.sync_username and options.sync_password and options.passphrase):
-        print '\nFirefox Sync account credentials not specified.'
+        print('\nFirefox Sync account credentials not specified.')
 
     # Print the user instructions
-    print usage_message.format(TARGET=target,
-                               BIN_NAME=bin_name)
+    print(usage_message.format(TARGET=target,
+                               BIN_NAME=bin_name))
 
 if __name__ == "__main__":
     main()
diff --git a/testing/tps/tps/cli.py b/testing/tps/tps/cli.py
index 63e8db0d40..81bdea4791 100644
--- a/testing/tps/tps/cli.py
+++ b/testing/tps/tps/cli.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import json
 import optparse
 import os
@@ -93,7 +94,7 @@ def main():
 
     rlock = RLock()
 
-    print 'using result file', options.resultfile
+    print('using result file', options.resultfile)
 
     extensionDir = config.get('extensiondir')
     if not extensionDir or extensionDir == '__EXTENSIONDIR__':
diff --git a/testing/tps/tps/firefoxrunner.py b/testing/tps/tps/firefoxrunner.py
index 3b7c143d89..7bf6ed30eb 100644
--- a/testing/tps/tps/firefoxrunner.py
+++ b/testing/tps/tps/firefoxrunner.py
@@ -3,6 +3,7 @@
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
 
+from __future__ import print_function
 import copy
 import httplib2
 import os
@@ -53,11 +54,11 @@ class TPSFirefoxRunner(object):
             os.remove(pathToBuild)
 
         # download the build
-        print 'downloading build'
+        print('downloading build')
         self.download_url(self.url, pathToBuild)
 
         # install the build
-        print 'installing %s' % pathToBuild
+        print('installing %s' % pathToBuild)
         mozfile.remove(self.installdir, True)
         binary = mozinstall.install(src=pathToBuild, dest=self.installdir)
 
diff --git a/testing/tps/tps/testrunner.py b/testing/tps/tps/testrunner.py
index 8e5aee6c83..fe0b367196 100644
--- a/testing/tps/tps/testrunner.py
+++ b/testing/tps/tps/testrunner.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import json
 import os
 import platform
@@ -164,7 +165,7 @@ class TPSTestRunner(object):
         f.write(msg)
         f.close()
         if printToConsole:
-            print msg
+            print(msg)
 
     def writeToResultFile(self, postdata, body=None,
                           sendTo=['crossweave@mozilla.com']):
@@ -347,7 +348,7 @@ class TPSTestRunner(object):
 
         self.log(logstr, True)
         for phase in phaselist:
-            print "\t%s: %s" % (phase.phase, phase.status)
+            print("\t%s: %s" % (phase.phase, phase.status))
 
         return resultdata
 
@@ -428,9 +429,9 @@ class TPSTestRunner(object):
             self.rlock.release()
 
         # dump out a summary of test results
-        print 'Test Summary\n'
+        print('Test Summary\n')
         for test in self.postdata.get('tests', {}):
-            print '%s | %s | %s' % (test['state'], test['name'], test['message'])
+            print('%s | %s | %s' % (test['state'], test['name'], test['message']))
 
     def run_test_group(self):
         self.results = []
@@ -476,7 +477,7 @@ class TPSTestRunner(object):
             else:
                 self.numfailed += 1
                 if self.stop_on_error:
-                    print '\nTest failed with --stop-on-error specified; not running any more tests.\n'
+                    print('\nTest failed with --stop-on-error specified; not running any more tests.\n')
                     break
 
         self.mozhttpd.stop()
diff --git a/testing/xpcshell/mach_commands.py b/testing/xpcshell/mach_commands.py
index d821ff46fb..dc6033cdd5 100644
--- a/testing/xpcshell/mach_commands.py
+++ b/testing/xpcshell/mach_commands.py
@@ -29,7 +29,7 @@ from xpcshellcommandline import parser_desktop, parser_remote
 here = os.path.abspath(os.path.dirname(__file__))
 
 if sys.version_info[0] < 3:
-    unicode_type = unicode
+    unicode_type = str
 else:
     unicode_type = str
 
@@ -124,7 +124,7 @@ class XPCShellRunner(MozbuildObject):
         # Python through 2.7.2 has issues with unicode in some of the
         # arguments. Work around that.
         filtered_args = {}
-        for k, v in kwargs.iteritems():
+        for k, v in kwargs.items():
             if isinstance(v, unicode_type):
                 v = v.encode('utf-8')
 
diff --git a/testing/xpcshell/mach_test_package_commands.py b/testing/xpcshell/mach_test_package_commands.py
index fc7d273859..c8a8169026 100644
--- a/testing/xpcshell/mach_test_package_commands.py
+++ b/testing/xpcshell/mach_test_package_commands.py
@@ -44,7 +44,7 @@ def run_xpcshell(context, **kwargs):
     if args.testPaths:
         test_root = os.path.join(context.package_root, 'xpcshell', 'tests')
         normalize = partial(context.normalize_test_path, test_root)
-        args.testPaths = map(normalize, args.testPaths)
+        args.testPaths = list(map(normalize, args.testPaths))
 
     import runxpcshelltests
     xpcshell = runxpcshelltests.XPCShellTests(log=log)
